{       GranPrimo Component Library                     }
{       Debug and control application via web           }
{                                                       }
{       Copyright (c) 2001-2004 Antonio Alczar Ruiz    }
{*******************************************************}


type

// extend a TidHttpserver with my TspyIndy component
  TSpyIndy = class(TIdCustomHTTPServer)
  private
    fspy:TspyScreen;
    finspect:TSpyceFiles;
    fhome:TgpHome;
  protected
    fclase:tComponentClass;
    ffuncion:Tspyfuncion;
      {$ifndef netnet}

     procedure GetEvent(
    AThread: TIdPeerThread;
              Request: TIdHTTPRequestInfo; Response: TIdHTTPResponseInfo) ;
      {$else netnet}

    procedure GetEvent(AContext:TIdContext;
              Request: TIdHTTPRequestInfo; Response: TIdHTTPResponseInfo) ;
      {$ENDIF netnet}

    procedure myBeforeDispatch (rere:TResponRequest; var hadled:boolean);
    function TestSpy:tspyscreen;
    procedure setfuncion (ff:Tspyfuncion);
  public
    constructor Create(AOwner: TComponent); override;
    property spy:tspyscreen read testspy write fspy;
    property defaultport;
  published
    property clas:tcomponentClass read fclase write fclase;
    property funcion:TspyFuncion read ffuncion write setfuncion;
    property home:TgpHome read fhome;

  end;

  // extend a TidHttpserver with custom spice function
  TSpiceIndy = class(TSpyIndy)
  public
    constructor Create(AOwner: TComponent); override;
  end;



procedure Register;


implementation

procedure register;
Begin
 registerComponents ('miPrimo',[TSpyIndy,TSpiceIndy]);
end;


function TSpyIndy.TestSpy:tspyScreen;
begin
  if fspy=nil then
  begin
   fspy:=tspyScreen(clas.create (self));
   fspy.Funcion:=funcion;
   finspect:=TSpyceFiles(fspy.MakeSpyce(TSpyceFiles));
//   finspect.spyobject:=owner;
   fspy.testLogAuto; // activate spy actions
   fspy.BeforeDispatch:=myBeforeDispatch;
   fhome:=TgpHome (fspy.MakeSpyce(TgpHome));

{   if funcion <>sspice then
        fspy.addaction_(fspy.passwords.login,LoginAction);}
  end;
  result:=fspy
end;


constructor TSpyIndy.Create(AOwner: TComponent);
begin
  inherited;
  fspy:=nil;
  finspect:=nil;
  funcion:=sjprimo;
  OnCommandGet :=getevent; // patch onCommandGet event for handle by spy
  clas:=tspyScreen;
end;


procedure TSpyIndy.myBeforeDispatch
        (rere:TResponRequest; var hadled:boolean);
begin
  hadled:=true;
  if TestSpy<>nil then
  if spy.passwords.passwordAdmin<>'' then
  if (rere.Document<>spy.passwords.home)  then
  if not spy.passwords.IsOkRemoteAddr(rere) then
     hadled:=false
end;

      {$ifndef netnet}

procedure TSpyIndy.GetEvent(AThread: TIdPeerThread;
              Request: TIdHTTPRequestInfo; Response: TIdHTTPResponseInfo) ;
var rere:TResponRequest;
begin
 if testspy=nil then exit;
 rere:=TResponRequest.createadi(spy,request,nil,{tspyThread( AThread),}request.RemoteIP);
 // assign the ask in RequestInfo class to TResponRequest
 trace( Request.document);

 rere.Method:=Request.Command;
 rere.posted:=Request.UnparsedParams;
 rere.Document := Request.Document;
 if rere.method='GET' then
 begin
  rere.queryfields.Assign(Request.Params);
 end else
 begin
  rere.queryfields.text:=request.QueryParams;//);//Request.Params);
 end;
 try // dispatch the action by spy
     finspect.DispatchAction (rere,true,true);
 except
      on E: Exception do begin
         //rere.ResponseNo := 500;
         rere.Writes( E.Message);
      end;
 end;
 rere.doneresponse;  // render the result in a stream response
 if rere.ResponStream<>nil then
 begin
  Response.ContentType:=rere.ContentType;
  Response.ContentLength := rere.ResponStream.size;
  Response.WriteHeader;
  aThread.Connection.WriteStream(rere.ResponStream);
 end;
 rere.free;
end;
      {$else netnet}

    procedure TSpyIndy.GetEvent(AContext:TIdContext;
              Request: TIdHTTPRequestInfo; Response: TIdHTTPResponseInfo) ;
var rere:TResponRequest;
  st:string;
begin
 if testspy=nil then exit;
 trace( Request.document);

 rere:=TResponRequest.createadi(spy,request,nil,request.RemoteIP);
 // assign the ask in RequestInfo class to TResponRequest
 rere.Method:=Request.Command;
 rere.posted:=Request.UnparsedParams;
 rere.Document := Request.Document;
 spy.tip(request.document);

 if rere.method='GET' then
 begin
  rere.queryfields.Assign(Request.Params);
 end else
 begin
  rere.queryfields.text:=request.QueryParams;//);//Request.Params);
 end;
 try // dispatch the action by spy
     home.DispatchAction (rere,true,true);

 except
      on E: Exception do begin
         //rere.ResponseNo := 500;
         rere.Writes( E.Message);
      end;
 end;
 rere.doneresponse;  // render the result in a stream response
 if rere.ResponStream<>nil then
 begin
  Response.ContentType:=rere.ContentType;
  response.ContentStream:=rere.responStream;
  response.FreeContentStream:=false;
  Response.WriteHeader;
  Response.Writecontent;
 end else
 begin
//   sitrace_('mal');
 end;
 rere.free;
end;
{$ENDIF netnet}


constructor TSpiceIndy.Create(AOwner: TComponent);
begin
  inherited;
  Funcion:=sffiles;
  {$ifndef netnet}
  if not isRegspice then
     RegistraSpice;
  {$ENDIF netnet}
end;

procedure TspyIndy.setfuncion (ff:Tspyfuncion);
begin
 ffuncion:=ff;
 if fspy<>nil then fspy.funcion:=ff
end;


end.





